﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Threading;

namespace WpfApplication2
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
			DataItem item = new DataItem()
			{
				MinValue = DateTime.Now,
				MaxValue = DateTime.Now
			};
			this.DataContext = item;
			DispatcherTimer timer = new DispatcherTimer() { Interval = TimeSpan.FromSeconds(1) };
			timer.Tick += (o, e) =>
			{
				item.MaxValue = DateTime.Now;
			};
			timer.Start();
		}
	}

	public class DataItem : INotifyPropertyChanged
	{
		private DateTime minValue;

		public DateTime MinValue
		{
			get
			{
				return this.minValue;
			}
			set
			{
				if (this.minValue != value)
				{
					this.minValue = value;
					this.OnPropertyChanged("MinValue");
				}
			}
		}

		private DateTime maxValue;

		public DateTime MaxValue
		{
			get
			{
				return this.maxValue;
			}
			set
			{
				if (this.maxValue != value)
				{
					this.maxValue = value;
					this.OnPropertyChanged("MaxValue");
				}
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;

		private void OnPropertyChanged(string propertyName)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

	}
}
